;
; v. 1.02 1996 Aug 15 13:31:27
;  copyright (c) W. Lenerz 1996



*************************************************************************
*
* GGET, GSET, GDEL keywords
*
* syntax: result$=GGET  (what_global$)
*	        GSET  what_global$,value_of_global$
*	        GDEL  what_global$
*	        GFRST what_global$,value_of_global$
*
*	where:	global$ is the name of the variable
*		value_of_global$ is the value of this global variable
*		for GFRST and GNEXT, they are filled in on return!
***************************************************************************



	section	text

	xdef	gget
	xdef	gset
	xdef	gdel
	xdef	gfrst
	xdef	gnext
	include	asm_includes_asm

	xref	gu_achp
	xref	gu_rchp
	xref	use_thg
	xref	free_thg
	xref	rt_str		; returns string to SBASIC (asm_lib_returnparams)
	xref	rt_str2		; returns string in modified param (asm_lib_returnparams)
	xref	getstr		; gets string, on exit D1 = length, A1 points to string (prowess_asm_getstr)

out3	MOVEQ	#-15,D0
out2	MOVE.L	A4,A0
	JSR	gu_rchp
out	RTS



gset	MOVE.L	#'SET ',D7	; uses the SET extension in the thing
	LEA	8(A3),A5	; point to 1st parameter
	BSR	getstr		; get parameter
	BNE.S	out
	BSR	gmem		; get some mem
	BNE.S	out
	BSR	copyto		; copy first param to my mem space
	MOVE.L	A0,D5
	ADDQ.L	#1,D5		; make sure address is even
	BCLR	#0,D5		; space for next param
	MOVE.L	A5,A3
	ADDQ.L	#8,A5		; point to second parameter
	BSR	getstr		; get it
	BNE.S	out2
	MOVE.L	D1,D4		; length
	MOVE.L	D5,A0		; copy it to here....
	BSR.S	copyto		; ... now
	BSR	usethg		; use glob var thing
	BNE.S	out2
	MOVE.L	D5,-(A7)	; value of glob var
	MOVE.L	A4,-(A7)	; glob var to set
	JSR	$18(A1)		; do extension in thing now
	ADDQ.L	#8,A7		; readjust stack
	MOVE.L	D0,D7		; keep error
	LEA	globals,A0
	JSR	free_thg	; free this thing
	MOVE.L	D7,D0		; get error back
	MOVE.L	A4,A0		; point to my mem space
	JMP	gu_rchp		; release mem & return with old error


* -------------------------------------------------------------------
gdel	MOVE.L	#'DELE',D7
	BRA.S	com1
gget	MOVE.L	#'GET ',D7
com1	BSR	getstr		; get parameter
	BNE.S	out
	BSR.S	gmem		; get some mem, also puts length in D4
	BNE.S	out
	BSR.S	copyto		; copy string to this mem
	BSR.S	usethg
	BNE.S	out2
	MOVE.L	#512,-(A7)	; max space
	MOVE.L	A4,-(A7)	; value of this global var to be retured
	MOVE.L	A4,-(A7)	; glob var to search for (same address!!)
	JSR	$18(A1)		; do extension in thing now
	ADD.L	#12,A7		; readjust stack
	MOVE.L	D0,-(A7)	; keep error
	LEA	globals,A0
	JSR	free_thg	; free the thing
	MOVE.L	(A7)+,D0	; get error back
	CMP.L	#'GET ',D7
	BEQ.S	do_end1
	RTS



gmem	MOVE.L	D1,D4
	MOVE.L	#512,D0		; we want that much memory
	JSR	gu_achp
	MOVE.L	A0,A4		; get mem & put address in A4
	TST.L	D0
	RTS


; this copies string from (A1) to (A0), length in D4, puts a 0 at end
; of string
copyto	SUBQ.W	#1,D4		; prepare for dbf
lp1	MOVE.B	(A1)+,(A0)+	; copy string across
	DBF	D4,lp1
	MOVE.B	#0,(A0)+	; 'C' string uses null at end of string
	RTS
; this uses the thing, with D7 holding the extension key
usethg	LEA	globals,A0
	MOVE.L	D7,D2		; use this extension
	JMP	use_thg		; use the extension in the thing now


otest	CMP.L	#-7,D0		; is error not found?
	BNE	out2		; no, oops! ->...
	MOVE.L	A4,A0		; yes , so release mem
	JSR	gu_rchp
	MOVE.L	$58(A6),A1	; point to math stack now
	SUBQ.L	#4,A1
	MOVE.L	A1,$58(A6)
	MOVE.L	#$00022D2D,(A6,A1.L) ; this puts '--' on stack
	MOVEQ	#1,D4
	MOVEQ	#0,D0
	RTS



; this returns 1 parameter, pointed to by A4, to Basic , releases mem pointed
; to by A4
do_end1	TST.L	D0		; any error?
	BNE.S	otest		; ooops? do some tests ->...

	MOVE.L	A4,A3
	BSR.S	countlen
	MOVEQ	#0,D1
	MOVE.W	D4,D1		; this is length of string
	ADDQ.W	#3,D1		; add length word + ...
	BCLR	#0,D1		; ... make sure D1 is even
	MOVE.L	D1,D5		; keep it
	MOVE.L	$58(A6),A1
	MOVE.W	$11A,A2
	JSR	(A2)		; get space on maths stack
	SUB.L	D5,$58(A6)	; we need that much on stack
	MOVE.L	$58(A6),A1	; point to it
	MOVE.L	A4,A0		; our mem here
	MOVE.W	D4,(A6,A1.L)	; length of string
	BEQ.S	end1		; if empty string ->...
	ADDQ.L	#2,A1
	ADDQ.W	#1,D4
	LSR.W	#1,D4		; divide by two, for word sized ops
	SUBQ.W	#1,D4		; minus one, for DBF
strlp1	MOVE.W	(A4)+,(A6,A1.L)
	ADDQ.L	#2,A1
	DBF	D4,strlp1 ; copy string across
end1	JSR	gu_rchp		; release mem now
	MOVEQ	#0,D0		; no error
	MOVEQ	#1,D4		; signal 'return string'
out4	RTS			; and do it

; this counts the length of the 0-terminated string lying at A3
; A3 corr
; D4 = length of string on exit

countlen MOVEQ	#0,D4		; counter for length of string
lp2	TST.B	(A3)+		; loop until end
	BEQ.S	end_str
	ADDQ.W	#1,D4		; increase length counter
	BRA.S	lp2
end_str	RTS


*----------------------- GFRST, GNEXT ----------------------
gfgnoff	EQU	100

gnext	MOVE.L	#'NEXT',D7
	BSR	getstr
	BSR	gmem
	BSR	copyto
	BRA.S	com2
gfrst	MOVE.L	#'FRST',D7	; signal 1st
	BSR	gmem
com2	BSR	usethg		; use thing now
	LEA	gfgnoff(A4),A0
	MOVE.L	A4,-(A7)
	MOVE.L	A0,-(A7)	; value of variable lies here
	MOVE.L	A4,-(A7)	; name of variable will be here
	JSR	$18(A1)		; use extension now
	ADD.L	#12,A7		; reset stack
	MOVE.L	D0,D7
	LEA	globals,A0
	BSR	free_thg	; free thing now
	MOVE.L	D7,D0		; any error?
	BEQ.S	gngf_ok		; no, so continue->...
	CMP.L	#-10,D0		; is error 'end of file (no more?)
	BNE	out2		; no, so leave with error->...!
	MOVE.L	#$2D2D0000,(A4)	 ; SET TO '--' and put terminating 0
	MOVE.L	#$2D2D0000,gfgnoff(A4); set parameters to '--'
gngf_ok	SUBQ.L	#8,A5		; point to last parameter (value)
	LEA	gfgnoff(A4),A0	; this is where this lies
	MOVE.L	A0,A3		;
	BSR.S	countlen	; get length of string into D4
	BSR	rt_str2		; return this parameter to Basic
	LEA	-16(A5),A5	; point to first parameter
	MOVE.L	A4,A0		; and return it to basic after counting length
	MOVE.L	A4,A3
	BSR.S	countlen
	BSR	rt_str2
	MOVEQ	#0,D0		; signal no error
	BRA	out2		; rel mem & leave

globals	dc.w	glob2-*-2
	dc.b	'Global Variables'
glob2
	end
