; PWchange & PWbreak keywords for the Prowess Sbasic interface
; v. 1.02 1996 Aug 31 21:22:52
;  copyright (c) W. Lenerz



*************************************************************************
*
* This is the PWchange keyword
*
* syntax: PWchange object,tag[,taglist)][tag[,taglist]]...
*
* where: object is the object to remove
*	tag is the new tag for the object etc...
*
***************************************************************************



	section	text

	xdef	pwchange
	xdef	pwchangef
	include	asm_includes_asm

	xref	_pwchange
	xref	gmem		; get mem in my format (prowess_asm_gmem)
	xref	get_all		; get params & push onto stack (prowess_asm_getparams)
	xref	gu_rchp		; release common heap mem (gu_rechp)
	xref	err_out		; reset stack, rel mem & rts with error (prowess_asm_pwactivate)
	xref	e_o		; rel mem & rts with error (prowess_asm_pwactivate)
	xref	get_long	; get params & push onto stack (prowess_asm_getparams)
	xref	rt_int

pwchangef BSR.S	pwchange
	MOVE.W	D0,D4		; return the error
	BRA	rt_int		;

pwchange	BSR	gmem		; get some memory
	BSR	get_all		; push parameters onto stack
common	BNE	e_o		; oops
	MOVE.L	A4,A7		; new stack pointer
	BSR	_pwchange ; Prowess does all the work
	BRA	err_out		; this releses mem & returns with or...
				; ...w/o error as returned by prowess


*************************************************************************
*
* This is the PWbreak keyword
*
* syntax: PWbreak object
*
* where: object is the object used by the PWactivate call
*
***************************************************************************

	xdef	pwbreak

pwbreak	BSR	gmem		; get some memory
	MOVE.L	#0,-(A4)
	MOVE.L	#PW_SYSTEM_BREAKDOWN,-(A4) ; breakdown this system
	BSR	get_long		; get & push parameter onto stack
	BRA.S	common
	end
