; this is the PWquit keyword for the Prowess Sbasic interface
; v. 1.01     1997 Jan 15 13:25:19
;  copyright (c) W. Lenerz 1996

*************************************************************************
*
* This is the PWquit keyword
*
* syntax: PWquit object,result
*
* where:	object is the object which was activated
*	result is the result returned from the earlier PWactivate call
*	of the same object.
*
* this actually returns to prowess, tells it to breakdown the system, and
* sets the mempointer to 0 (just to be on the safe side)
***************************************************************************

	section	text
	xdef	pwquit

	include	asm_includes_asm

	xref	_pwchange
	xref	gmem		; gets mem in my format (prowess_asm_pwcreate)
	xref	get_para		; gets para from sbasic interpreter (prowess_asm_getparams)
	xref	get_param 	;  "   "	    "    "        "          "

err_out	MOVEQ	#-15,D0
out	RTS

pwquit	MOVE.L	A5,D0
	SUB.L	A3,D0
	SUB.L	#16,D0		; there must be two parameters
	BNE.S	err_out
	MOVEQ	#6,D1
	MOVE.W	$11A,A2
	JSR	(A2)		; get space on maths stack
	ADDQ.L	#8,A3		; point to second parameter
	MOVE.L	4(A6,A3.L),A4	; point to value
	BSR	get_para		; get it now
	BNE.S	out		; oops!
	MOVE.L	(A6,A1.L),D7	; this is the pointer to our memory
	BEQ.S	err_out		; oops?
	ADDQ.L	#8,A3		; point ot this again
	SUB.L	#6,$58(A6)	; make space on maths stack
	MOVE.L	$58(A6),A1
	MOVE.L	#0,(A6,A1.L)
	MOVE.W	#0,4(A6,A1.L)	; the parameter is 0
	MOVE.W	$120,A2
	JSR	(A2)		; set this parameter to 0 now (!)

do_return MOVE.L	D7,A0		; point to bottom of my area
	MOVE.L	(A0),A4		; point to top
	SUB.L	#12,A4		; jump over watermark
	MOVE.L	A0,-(A4)		; start of this space is kept here
	MOVE.L	A6,-(A4)
	MOVE.L	A3,-(A4)		; keep pointer to data
	MOVE.L	A7,-(A4)
	MOVE.L	4(A0),A7		; stack pointer within prowess

; we are now again within the prowess event handler...
	MOVE.L	#0,-(A7)		; NULL
	MOVE.L	#PW_SYSTEM_BREAKDOWN,-(A7)	; breakdown this system
	SUBQ.L	#8,A3
	BSR	get_para		; get the object
	MOVE.L	(A6,A1.L),-(A7)	; this object
	BSR	_pwchange 	; change this object (!)
	ADD.L	#12,A7		; reset stack pointer (3 long words)
	MOVEM.L	(A7)+,evtregs	; get regs back
	MOVE.L	(A7)+,D1
	MOVEQ	#0,D0		; no error
	RTS			; return to prowess now,this
				; then returns to basic

	end
