/*
	ProWesS, PROGS Windowing System

	ProWesS factor routines, to handle conversions from pixels to points and
	vice versa. Both stored in 16/16 fixpoint format.
	Pixel coordinates can be either real pixels, or virtual pixels. Virtual
	pixels assume a screen size of 16000x12000.

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 18 January 1995
*/

#include "ProWesS_h"

short XWindowSize, YWindowSize;
pt Xpixel2point, Ypixel2point;
pt Xpoint2pixel, Ypoint2pixel;

void PWCalculateFactors(short xsiz, short ysiz)
{
	XWindowSize=xsiz;
	YWindowSize=ysiz;

	Xpixel2point=short2pt(720)/xsiz;
	Ypixel2point=short2pt(540)/ysiz;

	Xpoint2pixel=short2pt(xsiz)/720;
	Ypoint2pixel=short2pt(ysiz)/540;
}

void PWpixel2point(pt *xfactor, pt *yfactor)
{
	*xfactor=Xpixel2point;
	*yfactor=Ypixel2point;
}

void PWpoint2pixel(pt *xfactor, pt *yfactor)
{
	*xfactor=Xpoint2pixel;
	*yfactor=Ypoint2pixel;
}
